//*****************************************
// 	Zv iOtBbNkbcgpj Program ATMega328
// CPU Clock:1MHz
//   iq[Yf[^@WāAUWlgɂj
//
//
//@LED1:DS1(PC5): 1=Light ON, 0=Light OFF
//
//  2017/05/30 New(TAB4)  Taishi
//*****************************************


#include	<avr/interrupt.h>
#include	<avr/io.h>
#include	<avr/pgmspace.h>
#include	<avr/sleep.h>
#include	<avr/eeprom.h>
#include	<string.h>
#include	<stdio.h>

#include	"pr_ake6_glcd.h"
#include	"glcd.h"
#include	"timer.h"
#include	"switch.h"
#include	"utility.h"
#include	"ake6.h"
#include	"disp_ake6.h"
#include	"rtc_ake6.h"

#define		Str_SW1					 ("SW-1")
#define		Str_SW2					 ("SW-2")
#define		Str_SW3					 ("SW-3")
#define		Str_space				 ("    ")

unsigned char	set_trim=0;			// lC

// **********************************************************
// ********************** Soft Timer ************************
// **********************************************************

volatile unsigned int	wait_i;
volatile unsigned char	wait_us;
// ************************************
// Delay 9uS
// t: uS (max 255)
// CPU Clock:1MHz
// ************************************
void delay_9us(unsigned char t)
{
	unsigned char	i;

	for(i=0;i<t;i++){
		wait_us++;				// 9uS Delay
	}
}
//***************************
// Wait
//  tm : Wait Time(ms) max. 8000
//***************************
void	delay_ms(int tm)
{

	for(wait_i = 0; wait_i < tm; wait_i++){
		delay_9us(1000/9);
	}
}

//***************************
//  Main
//***************************
int	main(void)
{

	unsigned char	i;
	unsigned char	old_sec;
	unsigned char	old_min;
	unsigned char	old_hou;
	unsigned char	old_day;
	unsigned char	old_mon;
	unsigned char	old_yer;
	unsigned char	ake6_mode = 1;
	unsigned char	req_adj_time = 0;

	delay_ms(100);

	led_init();

// kdceXg
	for(i=0;i<2;i++){
		led_on();												// LED ON
		delay_ms(500);
		led_off();												// LED OFF
		delay_ms(500);
	}


	init_lcd_G();
	disp_clear_lcd_G();
	sw_init();													//	SW PORT(PC) ݒ

	disp_lcd_G( 0, 0,(unsigned char *)"--   AT MEGA328   --");	// LCD Disolay String
	disp_lcd_G( 0, 1,(unsigned char *)"--    Ake6 glcd   --");	// LCD Disolay String
	disp_lcd_G( 0, 2,(unsigned char *)Version);					// LCD Disolay String
	disp_lcd_G( 0, 4,(unsigned char *)(__DATE__));				// LCD Disolay String
	disp_lcd_G( 12, 4,(unsigned char *)(__TIME__));				// LCD Disolay String

	for(i=0;i<20;i++){
		led_on();												// LED ON
		delay_ms(250);
		led_off();												// LED OFF
		delay_ms(250);
	}


	Timer0_init();												// Timer0 Initial

	Timer2_init();												// Timer2 Initial

	disp_clear_lcd_G();

	set_sleep_mode(SLEEP_MODE_PWR_SAVE);						// X[vFp[Z[u [h

	if(ake6_mode == 0){
		disp_ymdhms();											// Nb\
	}else{
		disp_ake6_full(1);										// Zv̑Sʕ\
	}
	old_sec = gRTC_sec;
	old_min = gRTC_min;
	old_hou = gRTC_hou;
	old_day = gRTC_day;
	old_mon = gRTC_mon;
	old_yer = gRTC_yer;

	read_bityousei();											// lǂݏo

	sei();														// 荞݉
	for(i=0;;i++){

		if(((~PINC) & SW2_ON_BIT) != 0){;						// PxڃXCb`f[^nm
			delay_ms(100);										// 100mS Delay
			if(((~PINC) & SW2_ON_BIT) != 0){;					// QxڃXCb`f[^nm
				ake6_mode ^= 1;									// \[hύX
				disp_clear_lcd_G();
				if(ake6_mode == 0){
					disp_ymdhms();								// Nb\
				}else{
					disp_ake6_full(1);							// Zv̑Sʕ\
				}
				old_sec = gRTC_sec;
				old_min = gRTC_min;
				old_hou = gRTC_hou;
				old_day = gRTC_day;
				old_mon = gRTC_mon;
				old_yer = gRTC_yer;
				wait_sw_off();									// XCb`nee҂
			}
		}

		if(ake6_mode == 0){
			if (old_yer != gRTC_yer){
				old_yer = gRTC_yer;
				disp_yer(gRTC_yer);								// N\
			}
			if (old_day != gRTC_mon){
				old_mon = gRTC_mon;
				disp_mon(gRTC_mon);								// N\
			}
			if (old_day != gRTC_day){
				old_day = gRTC_day;
				disp_day(gRTC_day);								// N\
			}
			if (old_hou != gRTC_hou){
				old_hou = gRTC_hou;
				disp_hou(gRTC_hou);								// b\
			}
			if (old_min != gRTC_min){
				old_min = gRTC_min;
				disp_min(gRTC_min);								// b\
			}
			if (old_sec != gRTC_sec){
				old_sec = gRTC_sec;
				disp_sec(gRTC_sec);								// b\
			}

		}else{
			if (old_min != gRTC_min){
				old_min = gRTC_min;
				disp_ake6_full(0);								// Zv̑Sʕ\
			}
			if (old_sec != gRTC_sec){
				old_sec = gRTC_sec;
				rtc_adjust_hour();								// PԖ̔
			}
		}

		if(((~PINC) & SW1_ON_BIT) != 0){;						// PxڃXCb`f[^nm
			delay_ms(100);										// 100mS Delay
			if(((~PINC) & SW1_ON_BIT) != 0){;					// QxڃXCb`f[^nm
				req_adj_time = 1;
			}
		}

		if(((~PINC) & SW3_ON_BIT) != 0){;						// PxڃXCb`f[^nm
			delay_ms(100);										// 100mS Delay
			if(((~PINC) & SW3_ON_BIT) != 0){;					// QxڃXCb`f[^nm
				set_trim = 1;									// lC
			}
		}

		if(req_adj_time != 0){									// vv
			if(ake6_mode != 0){
				disp_clear_lcd_G();
				disp_ymdhms();									// Nb\
			}
			adjust_time();										// v
			req_adj_time = 0;
			if(ake6_mode == 0){
				disp_ymdhms();									// Nb\
			}else{
				disp_clear_lcd_G();
				disp_ake6_full(1);								// Zv̑Sʕ\
			}
			old_sec = 0xff;
			old_min = 0xff;
			old_hou = 0xff;
			old_day = 0xff;
			old_mon = 0xff;
			old_yer = 0xff;
		}

		if(set_trim != 0){										// lC鎞
			adjust_bityo();										// l̏C
			set_trim = 0;										// l̏C͏I
			disp_clear_lcd_G();
			if(ake6_mode == 0){
				disp_yer(gRTC_yer);								// N\
				disp_mon(gRTC_mon);								// \
				disp_day(gRTC_day);								// \
				disp_hou(gRTC_hou);								// \
				disp_min(gRTC_min);								// \
				disp_sec(gRTC_sec);								// b\
			}else{
				disp_ake6_full(1);								// Zv̑Sʕ\
			}
			old_sec = gRTC_sec;
			old_min = gRTC_min;
			old_hou = gRTC_hou;
			old_day = gRTC_day;
			old_mon = gRTC_mon;
			old_yer = gRTC_yer;
		}

// XCb`M`FbN
#if	0
		if(((~PINC) & SW1_ON_BIT) != 0){;						// XCb`|P  f[^nm
			disp_lcd_G( 1, 2,(unsigned char *)Str_SW1);			// LCD Disolay String
		}else{
			disp_lcd_G( 1, 2,(unsigned char *)Str_space);		// LCD Disolay String
		}

		if(((~PINC) & SW2_ON_BIT) != 0){;						// XCb`|Q  f[^nm
			disp_lcd_G(  7, 2,(unsigned char *)Str_SW2);		// LCD Disolay String
		}else{
			disp_lcd_G(  7, 2,(unsigned char *)Str_space);		// LCD Disolay String
		}

		if(((~PINC) & SW3_ON_BIT) != 0){;						// XCb`|R  f[^nm
			disp_lcd_G( 13, 2,(unsigned char *)Str_SW3);		// LCD Disolay String
		}else{
			disp_lcd_G( 13, 2,(unsigned char *)Str_space);		// LCD Disolay String
		}
#endif

		sleep_mode();											// X[vڍs
	}

	while(1){
		;
	}
}
